#include <led-matrix-32-16.hpp>
#include <Arduino.h>

LedMetrix32x16 ledMatrix; // Create an instance of the LedMetrix32x16 class


void setup() {
  Serial.begin(115200); // Initialize serial communication for debugging
  ledMatrix.begin(1, 3); // Initialize the LED matrix with 1 rows and 3 column of panels
  MatrixPanel_I2S_DMA *display = ledMatrix.getDisplay(); // Get the DMA display object
  display->setBrightness(50); // Set the brightness of the display to 50%
}

void loop() {
  MatrixPanel_I2S_DMA *display = ledMatrix.getDisplay(); // Get the DMA display object
  CustomPxBasePanel *virtualDisplay = ledMatrix.getVirtualDisplay(); // Get the virtual display object
  
  // draw a red pixel at each position on the display
  for (int i = 0; i < virtualDisplay->height(); i++)
  {
    for (int j = 0; j < virtualDisplay->width(); j++)
    {
      virtualDisplay->drawPixel(j, i, virtualDisplay->color565(255, 0, 0)); // Draw a red pixel at (j, i)
      delay(10); // Delay to visualize the drawing
    }
  }
  delay(1000); // Wait for a second before starting over

  // Gradually turn brightness from Bright to Dim 
  for (int i = 255; i >= 0; i--)
  {
    display->setBrightness(i); // Gradually decrease brightness
    delay(10); // Delay to visualize the brightness change
  }
  
  // Gradually turn brightness from  Dim to Bright
  for (int i = 0; i <= 255; i++)
  {
    display->setBrightness(i); // Gradually increase brightness
    delay(10); // Delay to visualize the brightness change
  }
  delay(1000); // Wait for a second before starting over


  virtualDisplay->clearScreen(); // Clear the virtual display
  virtualDisplay->setTextSize(2); // Set text size to 2
  virtualDisplay->setTextColor(virtualDisplay->color565(255, 255, 255)); // Set text color to white
  for (int i = 0; i >= (-9 * 13); i--)
  {
    virtualDisplay->setCursor(i,0);          // Set cursor to the top-left corner
    virtualDisplay->println("Hello, World!"); // Print "Hello, World!" on the display
    delay(100);
    virtualDisplay->clearScreen(); // Clear the virtual display after each print
  }

  uint16_t color [] = { 
    virtualDisplay->color565(255, 0, 0),   // Red
    virtualDisplay->color565(0, 255, 0),   // Green
    virtualDisplay->color565(0, 0, 255),   // Blue
    virtualDisplay->color565(255, 255, 0), // Yellow
    virtualDisplay->color565(255, 0, 255), // Magenta
    virtualDisplay->color565(0, 255, 255)  // Cyan
  };

  virtualDisplay->clearScreen();  // Clear the virtual display
  virtualDisplay->setTextSize(1); // Set text size to 2
  for (int i = 0; i < sizeof(color) / sizeof(color[0]); i++)
  {
    virtualDisplay->setCursor(0, 0);          // Set cursor to the top-left corner
    virtualDisplay->setTextColor(color[i]);   // Set text color to white
    virtualDisplay->println("Hello, World!"); // Print "Hello, World!" on the display
    delay(3000);                              // Wait for 2 seconds to visualize the text
  }
}
